﻿Public Class NumberedRowBehavior

   Private _CurrentRowFont As Font
   Private WithEvents _DGV As DataGridView

   Public Shared Sub Register(ByVal DGV As DataGridView)
      With New NumberedRowBehavior
         ._DGV = DGV
         ._CurrentRowFont = New Font(DGV.RowHeadersDefaultCellStyle.Font, FontStyle.Bold)
      End With
   End Sub

   Private Sub New() 'verhindert externe Instanzierung
   End Sub

   Private Sub DGV_CellPainting(ByVal sender As Object, ByVal e As DataGridViewCellPaintingEventArgs) Handles _DGV.CellPainting
      '3 Ausschluß-Kriterien
      If e.ColumnIndex >= 0 OrElse e.RowIndex < 0 OrElse _DGV.Rows(e.RowIndex).IsNewRow Then Return
      With _DGV.RowHeadersDefaultCellStyle
         Dim font = If(e.RowIndex = _DGV.CurrentRow.Index, _CurrentRowFont, .Font)
         Dim selected = e.State.HasFlag(DataGridViewElementStates.Selected)
         Dim color = If(selected, .SelectionForeColor, .ForeColor)
         e.PaintBackground(e.CellBounds, selected)
         TextRenderer.DrawText(e.Graphics, e.RowIndex.ToString, font, e.CellBounds, color)
         e.Handled = True
      End With
   End Sub

   Private Sub _DGV_Disposed(ByVal sender As Object, ByVal e As EventArgs) Handles _DGV.Disposed
      _CurrentRowFont.Dispose()
   End Sub

End Class
